﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using OpenTK.Graphics.OpenGL;
using OpenTK;
using System.Drawing;

namespace LengthwiseShootingGame
{
	public class EnemyBurret : Character
	{
		public EnemyBurret(float x, float y, float vecX, float vecY)
		{
			X = x;
			Y = y;
			VecX = vecX;
			VecY = vecY;

			if(Textures.Count == 0)
				Textures = CreateTextures();
		}

		static List<int> Textures = new List<int>();

		protected override List<Bitmap> GetBitmaps()
		{
			Bitmap bitmap = Properties.Resources.sprite2;

			List<Bitmap> bitmaps = new List<Bitmap>();

			// 0
			{
				Bitmap bitmap1 = new Bitmap(8, 8);
				Graphics g = Graphics.FromImage(bitmap1);
				g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
				g.DrawImage(bitmap, new Rectangle(0, 0, 8, 8), new Rectangle(32, 49, 8, 8), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			//1
			{
				Bitmap bitmap1 = new Bitmap(12, 12);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 12, 12), new Rectangle(42, 47, 12, 12), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}

			return bitmaps;
		}

		public override void Draw()
		{
			GL.PushMatrix();
			{
				GL.Translate(X, Y, 0);

				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color.White);
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color.White);

				Radius = 0.1f;
				if(MoveCount % 8 < 4)
				{
					GL.BindTexture(TextureTarget.Texture2D, Textures[0]);
				}
				else
				{
					GL.BindTexture(TextureTarget.Texture2D, Textures[1]);
					Radius = 0.15f;
				}

				GL.Begin(BeginMode.Quads);
				{
					GL.Normal3(Vector3.UnitY);
					GL.TexCoord2(1, 0);
					GL.Vertex3(Radius, 0, Radius);
					GL.TexCoord2(0, 0);
					GL.Vertex3(-Radius, 0, Radius);
					GL.TexCoord2(0, 1);
					GL.Vertex3(-Radius, 0, -Radius);
					GL.TexCoord2(1, 1);
					GL.Vertex3(Radius, 0, -Radius);
				}
				GL.End();
				GL.BindTexture(TextureTarget.Texture2D, 0);
			}
			GL.PopMatrix();
		}
	}
}
