﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using OpenTK.Graphics.OpenGL;
using OpenTK;
using System.Drawing;

namespace LengthwiseShootingGame
{
	class Enemy2 : EnemyBase
	{
		public Enemy2(float x, float y, float radius, int life, int score)
		{
			X = x;
			Y = y;
			IsDead = false;
			Score = score;
			Life = life;
			Radius = radius;

			if(Textures.Count == 0)
				Textures = CreateTextures();
		}

		static List<int> Textures = new List<int>();

		protected override List<Bitmap> GetBitmaps()
		{
			Bitmap bitmap = Properties.Resources.sprite2;

			List<Bitmap> bitmaps = new List<Bitmap>();

			// ザコ敵（黄色）0
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(4, 63, 25, 28), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			// ザコ敵（黄色）1
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(36, 63, 25, 28), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			// ザコ敵（黄色）2
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(68, 63, 25, 28), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			// ザコ敵（黄色）3
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(99, 63, 25, 28), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			return bitmaps;
		}

		public override void Move()
		{
			Jiki jiki = Form1.Jiki;
			if(jiki == null)
				return;

			if(MoveCount % 32 == 0 && (Random.Next(2) == 0 || VecX == 0))
			{
				if(jiki.X < X)
					VecX = -0.2f;
				else
					VecX = 0.2f;
			}
			base.Move();
			Shot();
		}

		void Shot()
		{
			if(Random.Next(40) % 40 == 0)
			{
				int r = Random.Next(10);
				Form1.EnemyBurrets.Add(new EnemyBurret(X, Y, r * 0.02f - 0.1f, -0.1f));
			}
		}

		public override void Draw()
		{
			GL.PushMatrix();
			{
				GL.Translate(X, Y, 0);

				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color.White);
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color.White);

				if(MoveCount % 8 < 2)
					GL.BindTexture(TextureTarget.Texture2D, Textures[0]);
				else if(MoveCount % 8 < 4)
					GL.BindTexture(TextureTarget.Texture2D, Textures[1]);
				else if(MoveCount % 8 < 6)
					GL.BindTexture(TextureTarget.Texture2D, Textures[2]);
				else if(MoveCount % 8 < 8)
					GL.BindTexture(TextureTarget.Texture2D, Textures[3]);

				GL.Begin(BeginMode.Quads);
				{
					GL.Normal3(Vector3.UnitY);
					GL.TexCoord2(1, 0);
					GL.Vertex3(Radius, 0, Radius);
					GL.TexCoord2(0, 0);
					GL.Vertex3(-Radius, 0, Radius);
					GL.TexCoord2(0, 1);
					GL.Vertex3(-Radius, 0, -Radius);
					GL.TexCoord2(1, 1);
					GL.Vertex3(Radius, 0, -Radius);
				}
				GL.End();
				GL.BindTexture(TextureTarget.Texture2D, 0);
			}
			GL.PopMatrix();
		}
	}
}
