﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using OpenTK.Graphics.OpenGL;
using OpenTK;
using System.Drawing;

namespace LengthwiseShootingGame
{
	public class Explosion: Character
	{
		public Explosion(float x, float y, float vecX, float vecY, float radius)
		{
			X = x;
			Y = y;
			VecX = vecX;
			VecY = vecY;

			Radius = radius;

			if(Textures.Count == 0)
				Textures = CreateTextures();
		}

		static List<int> Textures = new List<int>();

		protected override List<Bitmap> GetBitmaps()
		{
			Bitmap bitmap = Properties.Resources.sprite2;

			List<Bitmap> bitmaps = new List<Bitmap>();

			// 爆発
			// 0
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(17, 340, 24, 27), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			//1
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(44, 340, 30, 30), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			//2
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(79, 340, 32, 32), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			//3
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(116, 340, 36, 36), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			//4
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(153, 340, 34, 34), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}
			//5
			{
				Bitmap bitmap1 = new Bitmap(25, 28);
				Graphics g = Graphics.FromImage(bitmap1);
				g.DrawImage(bitmap, new Rectangle(0, 0, 25, 28), new Rectangle(188, 340, 28, 30), GraphicsUnit.Pixel);
				g.Dispose();
				bitmaps.Add(bitmap1);
			}

			return bitmaps;
		}

		public override void Draw()
		{
			GL.PushMatrix();
			{
				GL.Translate(X, Y, 0);

				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color.White);
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color.White);

				int i = MoveCount % 13;
				if(i < 2)
					GL.BindTexture(TextureTarget.Texture2D, Textures[0]);
				else if(i < 4)
					GL.BindTexture(TextureTarget.Texture2D, Textures[1]);
				else if(i < 6)
					GL.BindTexture(TextureTarget.Texture2D, Textures[2]);
				else if(i < 8)
					GL.BindTexture(TextureTarget.Texture2D, Textures[3]);
				else if(i < 10)
					GL.BindTexture(TextureTarget.Texture2D, Textures[4]);
				else if(i < 12)
					GL.BindTexture(TextureTarget.Texture2D, Textures[5]);
				else
				{
					IsDead = true;
					return;
				}

				GL.Begin(BeginMode.Quads);
				{
					GL.Normal3(Vector3.UnitY);
					GL.TexCoord2(1, 0);
					GL.Vertex3(Radius, 0, Radius);
					GL.TexCoord2(0, 0);
					GL.Vertex3(-Radius, 0, Radius);
					GL.TexCoord2(0, 1);
					GL.Vertex3(-Radius, 0, -Radius);
					GL.TexCoord2(1, 1);
					GL.Vertex3(Radius, 0, -Radius);
				}
				GL.End();
				GL.BindTexture(TextureTarget.Texture2D, 0);
			}
			GL.PopMatrix();
			//MoveCount++;
		}
	}

	public class Explosion2 : Explosion
	{
		public Explosion2(float x, float y, float vecX, float vecZ, float radius) :base(x, y, vecX, 0, radius)
		{
			X = x;
			Y = y;
			VecX = vecX;
			VecZ = vecZ;

			Radius = radius;

			if(Textures.Count == 0)
				Textures = CreateTextures();
		}

		static List<int> Textures = new List<int>();

		float Z = 0;
		float VecZ = 0;

		public override void Move()
		{
			X += VecX;
			Z += VecZ;

			MoveCount++;
		}

		public override void Draw()
		{
			GL.PushMatrix();
			{
				GL.Translate(X, Y, Z);

				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color.White);
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color.White);

				if(MoveCount < 4)
					GL.BindTexture(TextureTarget.Texture2D, Textures[0]);
				else if(MoveCount < 8)
					GL.BindTexture(TextureTarget.Texture2D, Textures[1]);
				else if(MoveCount < 12)
					GL.BindTexture(TextureTarget.Texture2D, Textures[2]);
				else if(MoveCount < 16)
					GL.BindTexture(TextureTarget.Texture2D, Textures[3]);
				else if(MoveCount < 20)
					GL.BindTexture(TextureTarget.Texture2D, Textures[4]);
				else if(MoveCount < 24)
					GL.BindTexture(TextureTarget.Texture2D, Textures[5]);
				else
				{
					IsDead = true;
					return;
				}

				GL.Begin(BeginMode.Quads);
				{
					GL.Normal3(Vector3.UnitY);
					GL.TexCoord2(1, 0);
					GL.Vertex3(Radius, 0, Radius);
					GL.TexCoord2(0, 0);
					GL.Vertex3(-Radius, 0, Radius);
					GL.TexCoord2(0, 1);
					GL.Vertex3(-Radius, 0, -Radius);
					GL.TexCoord2(1, 1);
					GL.Vertex3(Radius, 0, -Radius);
				}
				GL.End();
				GL.BindTexture(TextureTarget.Texture2D, 0);
			}
			GL.PopMatrix();
		}

	}
}
