﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using OpenTK.Graphics.OpenGL;
using OpenTK;
using System.Drawing;

namespace LengthwiseShootingGame
{
	public class Jiki: Character
	{
		public Jiki(float radius, float vecY)
		{
			if(Textures.Count == 0)
				Textures = CreateTextures();

			VecY = vecY;
			Radius = radius;
			Life = MaxLife;
		}

		public int MaxLife = 50;
		static List<int> Textures = new List<int>();

		protected override List<Bitmap> GetBitmaps()
		{
			Bitmap bitmap = Properties.Resources.sprite2;

			List<Bitmap> bitmaps = new List<Bitmap>();

			Bitmap bitmap1 = new Bitmap(42, 45);
			Graphics g = Graphics.FromImage(bitmap1);
			g.DrawImage(bitmap, new Rectangle(0, 0, 42, 45), new Rectangle(57, 0, 42, 45), GraphicsUnit.Pixel);
			g.Dispose();
			bitmaps.Add(bitmap1);

			return bitmaps;
		}

		public float RotateY = 0;

		public override void Move()
		{
			X += VecX;
			Y += VecY;

			if(VecX< 0)
				RotateY = -10f;
			if(VecX > 0)
				RotateY = 10f;
			if(VecX == 0)
				RotateY = 0;

			if(X < -4)
				X = -4;
			if(X > 4)
				X = 4;
			if(Y < Form1.BaseY)
				Y = Form1.BaseY;
			if(Y > Form1.BaseY + 4)
				Y = Form1.BaseY + 4;

			MoveCount++;
		}

		public override void Draw()
		{
			if(IsMuteki)
			{
				if(MoveCount % 4 < 2)
					return;
			}

			GL.PushMatrix();
			{
				GL.Translate(X, Y, 0);
				GL.Rotate(RotateY, 0, 1, 0);

				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color.White);
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color.White);

				GL.BindTexture(TextureTarget.Texture2D, Textures[0]);

				GL.Begin(BeginMode.Quads);
				{
					GL.Normal3(Vector3.UnitY);
					GL.TexCoord2(1, 0);
					GL.Vertex3(Radius, Radius, 0);
					GL.TexCoord2(0, 0);
					GL.Vertex3(-Radius, Radius, 0);
					GL.TexCoord2(0, 1);
					GL.Vertex3(-Radius, -Radius, 0);
					GL.TexCoord2(1, 1);
					GL.Vertex3(Radius, -Radius, 0);
				}
				GL.End();
				GL.BindTexture(TextureTarget.Texture2D, 0);
			}
			GL.PopMatrix();
		}

		bool _isMuteki = false;
		public bool IsMuteki
		{
			get{ return _isMuteki; }
			set
			{
				_isMuteki = value;
				//IsBackColorRed = true;

				if(value == true)
				{
					System.Windows.Forms.Timer timer1 = new System.Windows.Forms.Timer();
					timer1.Tick += Timer_Tick1;
					timer1.Interval = 1000;
					timer1.Start();
				}

				void Timer_Tick1(object sender, EventArgs e)
				{
					System.Windows.Forms.Timer t = (System.Windows.Forms.Timer)sender;
					t.Stop();
					t.Dispose();
					_isMuteki = false;
				}
			}
		}

		public bool _isBackColorRed = false;
		public bool IsBackColorRed
		{
			get { return _isBackColorRed; }
			set
			{
				_isBackColorRed = value;

				if(value == true)
				{
					System.Windows.Forms.Timer timer1 = new System.Windows.Forms.Timer();
					timer1.Tick += Timer_Tick1;
					timer1.Interval = 100;
					timer1.Start();
				}

				void Timer_Tick1(object sender, EventArgs e)
				{
					System.Windows.Forms.Timer t = (System.Windows.Forms.Timer)sender;
					t.Stop();
					t.Dispose();
					_isBackColorRed = false;
				}
			}
		}
	}
}
