﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using OpenTK.Graphics.OpenGL;
using OpenTK;
using System.Drawing;

namespace LengthwiseShootingGame
{
	public class JikiBurret : Character
	{
		public JikiBurret(float x, float y, float vecX, float vecY, float radius)
		{
			X = x;
			Y = y;
			VecX = vecX;
			VecY = vecY;
			Radius = radius;

			if(Textures.Count == 0)
				Textures = CreateTextures();
		}

		static List<int> Textures = new List<int>();

		protected override List<Bitmap> GetBitmaps()
		{
			Bitmap bitmap = Properties.Resources.sprite2;

			List<Bitmap> bitmaps = new List<Bitmap>();

			Bitmap bitmap1 = new Bitmap(5, 5);
			Graphics g = Graphics.FromImage(bitmap1);
			g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;
			g.DrawImage(bitmap, new Rectangle(0, 0, 5, 5), new Rectangle(4, 50, 5, 5), GraphicsUnit.Pixel);
			g.Dispose();
			bitmaps.Add(bitmap1);

			return bitmaps;
		}

		public override void Draw()
		{
			GL.PushMatrix();
			{
				GL.Translate(X, Y, 0);

				GL.Material(MaterialFace.Front, MaterialParameter.Ambient, Color.White);
				GL.Material(MaterialFace.Front, MaterialParameter.Diffuse, Color.White);

				GL.BindTexture(TextureTarget.Texture2D, Textures[0]);

				GL.Begin(BeginMode.Quads);
				{
					GL.Normal3(Vector3.UnitY);
					GL.TexCoord2(1, 0);
					GL.Vertex3(Radius, 0, Radius);
					GL.TexCoord2(0, 0);
					GL.Vertex3(-Radius, 0, Radius);
					GL.TexCoord2(0, 1);
					GL.Vertex3(-Radius, 0, -Radius);
					GL.TexCoord2(1, 1);
					GL.Vertex3(Radius, 0, -Radius);
				}
				GL.End();
				GL.BindTexture(TextureTarget.Texture2D, 0);
			}
			GL.PopMatrix();
		}
	}
}
